Subject: RE: Gratuitous ARP

From: Apoorva Bhatt <[email-masked]>
Date: Wed, 3 Jun 1998 10:47:34 -0700

-----Original Message-----
	From:	Acee Lindem [SMTP:[email-masked]]
	Sent:	Wednesday, June 03, 1998 10:29 AM
	To:	Tony Li
	Cc:	[email-masked]; [email-masked];
[email-masked]
	Subject:	Re: Gratuitous ARP

	Tony Li wrote:
	> 
	> David,
	> 
	> I was asking about systems that do not support router
discovery.  New
	> operating systems that do not support router discovery are
clearly simply
	> flawed.  BSD certainly now supports router discovery.  Does
Win98?  NT?
	> 
	> The ENTIRE point of HSRP was to support these legacy systems.
Router
	> discovery is a clearly better solution in every respect.
	> 
	> I won't claim to understand the technical design goals for
VRRP.  The
	> non-technical ones are obvious.

	VRRP supports systems which do not support gratuitous ARP just
as HSRP does. 
	The primary differences are:

	   1) VRRP does not require the concept of a virtual IP address.
A backup
	      router simply takes over forwarding responsibility for
hosts having
	      the master's IP address as their default gateway address.
RFC 2238 
	      explains (hopefully, clearly) what that entails. This
avoids the 
	      problems associated with ICMP redirects and the virtual IP
address. 

	I didn't get it here... But the endhosts are going to send
packets destined to the MacAddress of the Master Router which is down.
It's going to be until after 20 minutes (max) or after reboot that the
end host is going to learn of a new back-up router and thereby update
its ARP cache. (Page 63, TCP/IP Illustrated Volume 1 by Stevens).
	If I haven't gotten your point right, then please shed more
light here as to how to update the end host ARP cache entry.

	The problem is all endhost vendors do not comply 100% with ARP,
hence the whole issue we have here... Its because of this reason,
vendors have been forced to invent the hack of using multiple MacAddress
which is plain ugly!

	To HP-UX fellas, please submit your data facts here whether
HP-UX honors Gratuitous ARP or not.

	-Apoorva

	   2) VRRP runs on link basis rather than an IP subnet basis.
Consequently, 
	      a single VRID can be used for multiple subnets on the same
physical
	      network.   

	   3) VRRP's authentication encoding is more consistent with
other
	      protocols (e.g, RIPv2 and OSPF). However, this may be a
moot point
	      if one is using IPSEC encapsulation. 

	-- 
	Acee

---

From: Acee Lindem <[email-masked]>
Date: Wed, 03 Jun 1998 14:24:35 -0400

> light here as to how to update the end host ARP cache entry.

Sorry for the confusion. Since both VRRP and HRSP are based on the
concept of a virtual MAC, there is no problem with systems that do
not support gratuitous ARP. When a route takes over forwarding 
responsibility for a VRID, it begins receiving packets addressed to the
virtual MAC. 

> vendors have been forced to invent the hack of using multiple MacAddress

It is ugly but one of the goals of VRRP was to provide a transparent
redundancy mechanism for hosts. I don't think this should be changed (especially
now that we've already done the work in our device drivers ;-)). However,
the burned-in MAC address option is a good idea. 

-- 
Acee